///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//

#ifndef __GGRAPHIC_H
#define __GGRAPHIC_H

#include "../include/gomez.h"

class GGraphics {
		virtual void  	FASTCALL PutPixel(INT ,INT ,DWORD );
		virtual DWORD 	FASTCALL GetPixel(INT ,INT );
        virtual void	FASTCALL PutSpan(INT ,INT ,INT ,GPixel* );
        virtual void	FASTCALL GetSpan(INT ,INT ,INT ,GPixel* );
        virtual void	FASTCALL PutSpan(INT ,INT ,INT ,DWORD );

        virtual BOOL 	FASTCALL PutBitmap(GBitmap *,INT x,INT y);
        virtual GBitmap* FASTCALL GetBitmap(INT ,INT ,INT ,INT);
        virtual BOOL 	FASTCALL StretchBitmap(GBitmap *,INT x0,INT y0,INT x1,INT y1);

		virtual BOOL   	FASTCALL ClearImage(DWORD col=0);
		virtual GPixel*	FASTCALL GetImage(void);
		virtual GPixel*	FASTCALL GetImage(GPixel *,INT start=0,INT count=0);
		virtual GPixel*	FASTCALL PutImage(GPixel *,INT start=0,INT count=0);
		virtual CHAR*	FASTCALL GetFlagsName(CHAR *);
};


#endif