///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <dir.h>
#include <stdio.h>


LPSTR GetLoadFileName(HWND hwnd,LPSTR szTitle, LPSTR szFilter, LPSTR szFile, int StringSize)
{
  OPENFILENAME ofn;

  memset(&ofn, 0, sizeof(OPENFILENAME));

  ofn.lStructSize    = sizeof(OPENFILENAME);
  ofn.hwndOwner      = hwnd;
  ofn.lpstrFilter    = szFilter;
  ofn.nFilterIndex   = 1;
  ofn.lpstrFile      = szFile;
  ofn.nMaxFile       = StringSize;
  ofn.lpstrTitle     = szTitle;
  ofn.Flags = OFN_FILEMUSTEXIST|OFN_LONGNAMES;

  if (GetOpenFileName(&ofn) != TRUE)
   {
	DWORD Errval;
	char Errstr[50]="Common Dialog Error: ";
	char buf[5];

	Errval=CommDlgExtendedError();
	if (Errval != 0)
	   {
		wsprintf(buf, "%ld", Errval);
		strcat(Errstr, buf);
		MessageBox(NULL,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
	   }
	return NULL;
   }
 return szFile;
}



LPSTR GetSaveFileName(HWND hwnd,LPSTR szTitle, LPSTR szFilter, LPSTR szFile, int StringSize)
{
  OPENFILENAME ofn;

  memset(&ofn, 0, sizeof(OPENFILENAME));

  ofn.lStructSize    = sizeof(OPENFILENAME);
  ofn.hwndOwner      = hwnd;
  ofn.lpstrFilter    = szFilter;
  ofn.nFilterIndex   = 1;
  ofn.lpstrFile      = szFile;
  ofn.nMaxFile       = StringSize;
  ofn.lpstrTitle     = szTitle;
  ofn.Flags 	     = OFN_LONGNAMES;

  if (GetSaveFileName(&ofn) != TRUE)
   {
	DWORD Errval;
	char Errstr[50]="Common Dialog Error: ";
	char buf[5];

	Errval=CommDlgExtendedError();
	if (Errval != 0)
	   {
		wsprintf(buf, "%ld", Errval);
		strcat(Errstr, buf);
		MessageBox(NULL,Errstr,"WARNING",MB_OK|MB_ICONSTOP);
	   }

	return NULL;
   }

 return szFile;
}



BOOL ChooseColour(HWND hwnd,COLORREF *col)
{
 static COLORREF CustomColour[16];
 CHOOSECOLOR cc;

 cc.lStructSize=sizeof(cc);
 cc.hwndOwner=hwnd;
 cc.hInstance=NULL;
 cc.rgbResult=*col;
 cc.lpCustColors=CustomColour;
 cc.Flags=CC_RGBINIT;
 cc.lCustData=NULL;
 cc.lpfnHook=NULL;
 cc.lpTemplateName=NULL;

 if(ChooseColor(&cc))
   {
	*col=cc.rgbResult;
	return TRUE;
   }
 else
	return FALSE;
}
