///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#ifndef __GVEWIN_H
#define __GVEWIN_H

#define IDD_OBJPROPS_MESH			1
#define IDC_OBJPROPS_USEBOUNDING	101
#define IDC_OBJPROPS_RESET			102
#define IDC_OBJPROPS_MAKETRIANGLES	103
#define IDC_OBJPROPS_INITBOUNDING	104
#define IDC_OBJPROPS_INITNORMALS	105
#define IDC_OBJPROPS_SHADEVERTICES	106
#define IDC_OBJPROPS_BACKCULLING	107
#define IDC_OBJPROPS_OBJPHONG		108
#define IDC_OBJPROPS_OBJPALETTE		109
#define IDC_OBJPROPS_OBJSHADING		110
#define IDC_OBJPROPS_OBJCOLOUR		111
#define IDC_OBJPROPS_HIDE			112
#define IDC_OBJPROPS_NOSORT			113
#define IDC_OBJPROPS_TRANSFORMNORMALS	114

#define IDD_OBJPROPS_MATERIAL		2
#define IDC_OBJPROPS_BUMPDESC		201
#define IDC_OBJPROPS_LIGHTDESC		202
#define IDC_OBJPROPS_TEXDESC		203
#define IDC_OBJPROPS_BUMPMAP		204
#define IDC_OBJPROPS_LIGHTMAP		205
#define IDC_OBJPROPS_TEXMAP			206
#define IDC_OBJPROPS_BUMPSAVE		207
#define IDC_OBJPROPS_BUMPDELETE		208
#define IDC_OBJPROPS_BUMPLOAD		209
#define IDC_OBJPROPS_BUMPSELECT		210
#define IDC_OBJPROPS_LIGHTLOAD		211
#define IDC_OBJPROPS_LIGHTSAVE		212
#define IDC_OBJPROPS_LIGHTDELETE	213
#define IDC_OBJPROPS_LIGHTSELECT	214
#define IDC_OBJPROPS_TEXSELECT		215
#define IDC_OBJPROPS_TEXDELETE		216
#define IDC_OBJPROPS_TEXSAVE		217
#define IDC_OBJPROPS_TEXLOAD		218

#define IDD_OBJPROPS_LIGHT			3
#define IDC_OBJPROPS_LIGHTCHOOSE	301
#define IDC_OBJPROPS_LIGHTBLUE		302
#define IDC_OBJPROPS_LIGHTGREEN		303
#define IDC_OBJPROPS_LIGHTRED		304
#define IDC_OBJPROPS_AMBIENTBLUE	305
#define IDC_OBJPROPS_AMBIENTGREEN	306
#define IDC_OBJPROPS_AMBIENTRED		307
#define IDC_OBJPROPS_AMBIENTCHOOSE	308
#define IDC_OBJPROPS_LIGHTSPEC		309

#define IDD_OBJPROPS_GENERAL		4
#define IDC_OBJPROPS_ALLVERTEXCOUNT	401
#define IDC_OBJPROPS_ALLFACECOUNT	402
#define IDC_OBJPROPS_ALLOBJECTCOUNT	403
#define IDC_OBJPROPS_VERTEXCOUNT	404
#define IDC_OBJPROPS_FACECOUNT		405
#define IDC_OBJPROPS_NAME			406
#define IDC_OBJPROPS_TYPE			407

#define IDD_OBJPROPS_CAMERA			5
#define IDC_OBJPROPS_CAMZOOM		501
#define IDC_OBJPROPS_CAMYDIST		502
#define IDC_OBJPROPS_CAMXDIST		503

#define IDD_OBJCTRL					6
#define IDC_OBJCTRL_OBJNAME			600
#define IDC_OBJCTRL_DECROTZ			601
#define IDC_OBJCTRL_DECROTY			602
#define IDC_OBJCTRL_DECROTX			603
#define IDC_OBJCTRL_INCROTZ			604
#define IDC_OBJCTRL_INCROTY			605
#define IDC_OBJCTRL_INCROTX			606
#define IDC_OBJCTRL_INCPOSZ			607
#define IDC_OBJCTRL_INCPOSY			608
#define IDC_OBJCTRL_INCPOSX			609
#define IDC_OBJCTRL_DECPOSZ			610
#define IDC_OBJCTRL_DECPOSY			611
#define IDC_OBJCTRL_DECPOSX			612
#define IDC_OBJCTRL_ROTZ			613
#define IDC_OBJCTRL_ROTY			614
#define IDC_OBJCTRL_ROTX			615
#define IDC_OBJCTRL_POSZ			616
#define IDC_OBJCTRL_POSY			617
#define IDC_OBJCTRL_POSX			618

#define IDD_CAMCTRL					7
#define IDC_CAMCTRL_CAMNAME			700
#define IDC_CAMCTRL_INCPOSX			701
#define IDC_CAMCTRL_INCPOSY			702
#define IDC_CAMCTRL_INCPOSZ			703
#define IDC_CAMCTRL_DECPOSX			704
#define IDC_CAMCTRL_DECPOSY			705
#define IDC_CAMCTRL_DECPOSZ			706
#define IDC_CAMCTRL_DECROTX			707
#define IDC_CAMCTRL_DECROTY			708
#define IDC_CAMCTRL_DECROTZ			709
#define IDC_CAMCTRL_INCROTX			710
#define IDC_CAMCTRL_INCROTY			711
#define IDC_CAMCTRL_INCROTZ			712
#define IDC_CAMCTRL_ROTZ			713
#define IDC_CAMCTRL_ROTY			714
#define IDC_CAMCTRL_ROTX			715
#define IDC_CAMCTRL_POSZ			716
#define IDC_CAMCTRL_POSY			717
#define IDC_CAMCTRL_POSX			718



#define IDI_MAINICON				1
#define IDI_CONTAINERICON			7
#define IDI_OBJECTICON				6
#define IDI_MESHICON				5
#define IDI_LIGHTICON				4
#define IDI_ROOTICON				3
#define IDI_CAMERAICON				2

#define CM_FILE_NEW					101
#define CM_FILE_OPEN				102
#define CM_FILE_SAVE				103
#define CM_FILE_SAVEAS				104
#define CM_FILE_IMPORT				105
#define CM_FILE_EXIT				106

#define CM_OBJ_NEW 					201
#define CM_OBJ_NEWMESH				211
#define CM_OBJ_NEWCAMERA			212
#define CM_OBJ_NEWLIGHT				213
#define CM_OBJ_ATTRIBUTES			202
#define CM_OBJ_IMPORT				204
#define CM_OBJ_INFO					205
#define CM_OBJ_DELETE				207

#define CM_COLOUR_EDIT				401
#define CM_COLOUR_LOAD				402
#define CM_COLOUR_SAVE				403
#define CM_COLOUR_TABLES			404

#define CM_SHOW_CAMERA				701
#define CM_SHOW_LIGHT   			702
#define CM_SHOW_OBJECT 				703
#define CM_SHOW_OBJLIST				704

#define CM_OPT_DISPLAY				801
#define CM_OPT_SAVE					802
#define CM_OPT_LOAD					803
#define CM_OPT_INFO					804

#define CM_HLP_ABOUT				901
#define CM_HLP_BUILD				902



#define PM_CHANGE_OBJECTLIST		(WM_USER)
#define PM_CHANGE_OBJECT			(WM_USER+1)


BOOL	AppRegister(void);
BOOL 	AppLoadOptions(void);
BOOL 	AppSaveOptions(void);
BOOL 	AppSetFrameRect(void);
BOOL	AppRealizeObjectList(void);
BOOL	AppRealizeObject(void);
BOOL	AppRealizeWorld(void);

BOOL	DisplayObjectList(HWND hwnd);
BOOL	DestroyObjectList(HWND hwnd);

BOOL 	DisplayObjectProps(HWND hwnd);
BOOL 	DestroyObjectProps(HWND hwnd);

BOOL 	DisplayObjControl(HWND hwnd);
BOOL 	DestroyObjControl(HWND hwnd);

BOOL 	DisplayCamControl(HWND hwnd);
BOOL 	DestroyCamControl(HWND hwnd);

BOOL 	DisplayLightControl(HWND hwnd);
BOOL 	DestroyLightControl(HWND hwnd);


void   	MainMenu(HWND hwnd, int id, HWND hwndCtl,UINT codeNotify);


LRESULT CALLBACK MainWindowProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ObjectListProc(HWND, UINT, WPARAM, LPARAM);

LPSTR 	GetLoadFileName(HWND hwnd,LPSTR szTitle, LPSTR szFilter, LPSTR szFile, int StringSize);
LPSTR 	GetSaveFileName(HWND hwnd,LPSTR szTitle, LPSTR szFilter, LPSTR szFile, int StringSize);
BOOL	ChooseColour(HWND hwnd,COLORREF *col);


#endif
