///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#include "../include/gvepro.h"
void FASTCALL GDraw8_Nothing(drawPARAM);
void FASTCALL GDraw8_Vertex(drawPARAM);

GVectorSystem::GRasterTable GVectorSystem::RasterTable8[]={
	{GDraw8_Nothing, 			GVE_SF_8BIT | GVE_SF_ALLDETAIL},
	{NULL,						NULL}};



void FASTCALL GDraw8_Nothing(drawPARAM)
{
}


void FASTCALL GVectorSystem::Postprocessor8(PTR obuf,PTR nbuf,DWORD flags)
{
 if (flags & GVE_WRLD_MOTION_BLURR)
   {
	BYTE *nptr=(BYTE *)nbuf,*optr=(BYTE *)obuf;
	BYTE *last=(BYTE *)nbuf+GVectorSystem::FrameWidth*GVectorSystem::FrameHeight;

	while (nptr<last)
	   {
		*nptr=((BYTE *)GVectorSystem::GlassLUT)[(INT)*nptr + ((INT)(*optr)<<8)];
		nptr++;
		optr++;
	   }
   }
 if (flags & GVE_WRLD_SOFTEN_HORIZONTAL)
   {
	BYTE *nptr=(BYTE *)nbuf;
	BYTE *last=(BYTE *)nbuf+GVectorSystem::FrameWidth*GVectorSystem::FrameHeight-1;

	while (nptr<last)
	   {
		*nptr=((BYTE *)GVectorSystem::GlassLUT)[(INT)*nptr + ((INT)(*nptr+1)<<8)];
		nptr++;
	   }
   }
 if (flags & GVE_WRLD_SOFTEN_VERTICAL)
   {
	BYTE *nptr=(BYTE *)nbuf;
	BYTE *last=(BYTE *)nbuf+GVectorSystem::FrameWidth*(GVectorSystem::FrameHeight-1);

	while (nptr<last)
	   {
		*nptr=((BYTE *)GVectorSystem::GlassLUT)[(INT)*nptr + ((INT)(*nptr+GVectorSystem::FrameWidth)<<8)];
		nptr++;
	   }
   }
}



void FASTCALL GVectorSystem::Preprocessor8(PTR obuf,PTR nbuf,DWORD flags)
{
}


