///////////////////////////////////////////////////////////////////////////////
//
// (c) 1997 by Marc van Shaney , aka Kaya Memisoglu
//
// This Source-Code was written by and is copyrighted by Kaya Memisoglu
// You may use the whole code or only parts of it in your own programs
// whether they are commercial or not. BUT you must give credits for these
// parts to me (Kaya Memisoglu  or  Marc van Shaney).
// I am not responsible for any damage or loss caused by this program, so
// if you success in erasing your harddisk with this code, then it is your
// own fault and you should not claim me to be responsible...
// I would be very pleased if you also sent me a postcard or even a letter
// if you can use this code. My address:
//
//        Kaya Memisoglu
//        Reichenberger Ring 50
//        63512 Hainburg
//        Germany
//
//


#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "..\include\gvepro.h"
#include "gve4win.h"


EXTERN HINSTANCE    	hMainInstance;
EXTERN HWND 			hMainWindow,hObjectList,hObjCtrl,hCamCtrl,hLightCtrl;
EXTERN char				AppName[];
EXTERN char 			AppTitle[];
EXTERN char 			ErrTitle[];

EXTERN RECT 		 	ClientRect,MainRect,ObjectListRect;
EXTERN RECT				ObjControlRect,CamControlRect,LightControlRect;
EXTERN GVectorSystem 	VSystem;
EXTERN GVectorWorld  	*VWorld;
EXTERN GVectorObject 	*VObject;
EXTERN GVectorObject 	*VMesh;
EXTERN GLightObject  	*VLight;
EXTERN GCameraObject 	*VCamera;
EXTERN GRasterEngine	*VRasterEngine;


int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpszCmdParam,int nCmdShow)
{
 MSG Message;
 HACCEL accel;
 hMainInstance=hInst;

 if (!hPrevInst) AppRegister();
 AppLoadOptions();

 hMainWindow = CreateWindowEx(WS_EX_CLIENTEDGE,AppName, AppTitle, WS_OVERLAPPEDWINDOW,
	       MainRect.left, MainRect.top,
	       MainRect.right-MainRect.left+1,MainRect.bottom-MainRect.top+1,
	       NULL, NULL, hMainInstance, NULL);

 ShowWindow(hMainWindow,nCmdShow);
 UpdateWindow(hMainWindow);
 accel=LoadAccelerators(hMainInstance,"GVEMENU");

 while (GetMessage(&Message, NULL, 0, 0))
   {
	if (!TranslateAccelerator(hMainWindow,accel,&Message))
	   {
		if ((hObjCtrl) && IsDialogMessage(hObjCtrl,&Message)) continue;
		if ((hCamCtrl) && IsDialogMessage(hCamCtrl,&Message)) continue;
		if ((hLightCtrl) && IsDialogMessage(hLightCtrl,&Message)) continue;
		TranslateMessage(&Message);
	   }
	DispatchMessage(&Message);
   }

 AppSaveOptions();
 return Message.wParam;
}

